# $Id: inlinedecorate.rb,v 1.3 2001/01/01 05:25:25 not Exp $

=begin

  usage:

    {̈ȉ̕^Ot̕ɕϊ

    **foo**      ->   <strong>foo</strong>
    ***foo***    ->   <strong class="laud">foo</strong>
    --foo--      ->   <strike>foo</strike>

    SpXy[XŎn܂āÁstJbRɓǂ݂LĂ
    @fooshoget -> <ruby><rb>foo</rb><rp>(</rp><rt>hoge</rt><rp>)</rp></ruby>
  
    SpXy[XŎn܂āÃJbR uri LĂ
    @foo(http://hoge.com/)  ->  <a href="http://hoge.com/">foo</a>


   *݂(http://www.nekomimist.org/)A
    Ȃ肳(http://woinary.pobox.ne.jp//)̃R[hQlɍ쐬܂B

=end

class Filter
  def inlinedecorate(str, type)

    case type
    when :TOPIC, :P, :UL, :DL
      str.gsub!(/\*\*\*(.+?)\*\*\*/m, '<strong class="laud">\1</strong>')
      str.gsub!(/\*\*(.+?)\*\*/m, '<strong>\1</strong>')
      str.gsub!(/([^!]|^)--(.+?)--/m,'\1<strike>\2</strike>')
      str.gsub!(/@([^@]+)s(.+?)t/m, '<ruby><rb>\1</rb><rp>(</rp><rt>\2</rt><rp>)</rp></ruby>')
        
      # Link
      str.gsub!(/@([^@]+)\(((?:https?:|ftp:|mailto:|news:|\.)[^)]+)\)/, '<a href="\2">\1</a>')
    end

  end
end
