# $Id: monthindex.rb,v 1.2 2000/12/15 14:53:00 not Exp $

=begin

  monthindex.rb

    nDiary Plug-in  ʃt@C̃CfbNX쐬

    ʂ̃t@Cւ̃ÑCfbNX쐬܂B

    option:
      month=en        p\Lɂ܂B

      title=str       CfbNXɕt^Cgw肵܂B

      style=simple    <table> g킸ɃCfbNX쐬܂B
      style=table     <table> găCfbNX쐬܂B

      boder=n         style=table  berder  TCYw肵܂B
      cellspacing=n   style=table  cellspacing  TCYw肵܂B

      dst=filename    o͂ t@Cfilename ɐ؂肩܂

      exsample:
        <!--plug=monthindex?title=ߋ̓L?month=en?style=simple-->

=end


def plug(opt)

  case opt['month']
  when 'en'
    monthname =  %w(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec)
  else
    monthname =  %w(01 02 03 04 05 06 07 08 09 10 11 12)
  end

  opt['border'] = 1 if opt['border'] !~ /^\d+$/
  opt['cellspacing'] = 0 if opt['cellspacing'] !~ /^\d+$/

  firstYear = @months[0][0..3]
  lastYear = @months[@months.size - 1][0..3]

  monthPartNames = @monthPartNames.uniq
  monthPartNames.shift
  monthPartNames << ''

    case opt['style']
  when 'simple'
    index = "\n<ul class=\"monthindex\">\n"
    for year in firstYear..lastYear
      index << "\t<li><strong class=\"monthindex\">#{year}</strong> [ "
      for month in "01".."12"
        if @months.index(year + month)
          href = ''
          monthPartNames.each{ |part|
            if File::readable?(@outputDirectory + year + month + part + '.html')
              href = year + month + part + '.html'
              break
            end
          }
          index << "<a href=\"#{href}\">"
          index << monthname[month.to_i - 1] << '</a>, '
        else
          index << monthname[month.to_i - 1] << ', '
        end
      end

      index = index.chop.chop
      index << " ]</li>\n"
    end
    index << "</ul>"

    if opt['title'] then
      index = "<dl>\n<dt class=\"indexcaption\">#{opt['title']}</dt>\n<dd>#{index}</dd>"
      index << "\n</dl>\n\n"
    end

  else
    index  = "<table border=\"#{opt['border']}\" cellspacing=\"#{opt['cellspacing']}\">\n"

    if opt['title']
      index << '<tr><th colspan="13">' << opt['title'] << "</th></tr>\n"
    end

    for year in firstYear..lastYear
      index << "\t<tr>\n\t\t<th>#{year}</th>\n"
      for month in "01".."12"
        if @months.index(year + month)
          href = ''
          monthPartNames.each{ |part|
            if File::readable?(@outputDirectory + year + month + part + '.html')
              href = year + month + part + '.html'
              break
            end
          }
          index << "\t\t<td><a href=\"#{href}\">"
          index << monthname[month.to_i - 1] << "</a></td>\n"
        else
          index << "\t\t<td>" << monthname[month.to_i - 1] << "</td>\n"
        end
      end

      index << "\t</tr>\n\n"
    end
    index << "</table>\n\n"
  end

  if opt['dst'] and (not opt['dst'].empty?) then
    if /^([a-zA-Z]:)?\// !~ opt['dst'] then
      opt['dst'] = File::expand_path(opt['dst'], @outputDirectory)
    end
    begin
      outfile = open(opt['dst'], "w")
      outfile.print index
      outfile.close
      index = "<!--monthindex-->"
    rescue Errno::ENOENT
      $stderr.print "Plug-in error: monthindex > dst file not found!\n"
      index = "<!--plug-in error: monthindex-->"
    end
  end

  return index
end
